/*
	MicroView.win Copyright 1995 }V
	oga@dgw.yz.yamagata-u.ac.jp
*/

#include	"microview.h"

#include	"vbar.c"
#include	"vbars.c"

#define		EVENTA	(EventOpenON	\
			|EventRedrawON	\
			|EventCloseON	\
			|EventIconifyON	\
			|EventResizeON	\
			|EventKeyON	\
			|EventMouseSwitchON	)
#define		EVENTB	(EventOpenON	\
			|EventRedrawON	\
			|EventCloseON	\
			|EventMouseSwitchON	)

static void	buttonop( WindowID, EventInfo*, int );


static void
buttonop( wp, info, send )
WindowID	wp;
EventInfo	*info;
short	send;
{
	DrawBuf	dbuf[1];
	char	tbl[4]= { 'r', 'c', 'X', 'a' };
	int	butnum= info->x / 16;

	if( send ){
		if( butnum < 1 || butnum > 2 )	return;
	}else {
		if( butnum < 0 || butnum > 3 )	return;
	}

	info->KeyCode= tbl[butnum];
	butnum*= 16;
	DrawSetLine( dbuf, butnum, 0, butnum + 16 - 1, 16 - 1,
					3 + OptionXor, OptionFill );
	WindowDraw( wp, dbuf, 1 );
	info->option= EventKey;
	WindowSendEvent( wp, info );
	if( send ){
		DrawSetPut( dbuf, 0, 0, &VbarsPattern );
	}else {
		DrawSetPut( dbuf, 0, 0, &VbarPattern );
	}
	WindowDraw( wp, dbuf, 1 );
	return;
}


static
EventExecB( wp, info )
WindowID	wp;
EventInfo	*info;
{
	DrawBuf	dbuf[ 90+1 ];
	T_BUFP	*bp= HS_WindowGetClientPointer(wp);

	switch( info->option ){
	case EventOpen:
		WindowSetEventAttr( wp, EVENTB );
		return	TRUE;

	case EventRedraw: {
		int	dc= 1,
			i= info->y;
		unsigned int	y, yy;
		unsigned char	**ptr;

		DrawSetClear( dbuf, bp->backattr );
		if( i/= bp->font_z )	i--;
		ptr= bp->lp+i;
		y= i* bp->font_z;
		yy= info->v+ y+ bp->font_z+ bp->font_z;
		for(; y< yy && i < bp->line ; y+= bp->font_z, i++ )
			DrawSetSymbol( dbuf+dc++, 0, y, (char*)*ptr++,
							bp->attr, bp->font_y );
		WindowDraw( wp, dbuf, dc );
		return	TRUE;
	}

	case EventClose:
		WindowClose( wp );
		return	TRUE;

	case EventMouseSwitch:
		if( info->LeftON )
			ClipSetOperation( wp, info, (char**)bp->lp, bp->line,
				0, 0, FALSE, bp->attr, bp->font_z );
		return	TRUE;
	}
	return	FALSE;
}

static
EventExecA( wp, info )
WindowID	wp;
EventInfo	*info;
{
	DrawBuf	dbuf[9], *dp= dbuf;
	T_BUFP	*bp= HS_WindowGetClientPointer(wp);

	switch( info->option ){
	case EventOpen:
		WindowSetEventAttr( wp, EVENTA );
		return	TRUE;

	case EventRedraw: {
			int	x= HS_WindowGetViewSizeX(wp),
				y= HS_WindowGetViewSizeY(wp);

			DrawSetLine( dp++, 0, 0, x, 31, ColorGray, OptionFill );
			if( bp->send ){
				DrawSetPut( dp++, 0, 0, &VbarsPattern );
			}else {
				DrawSetPut( dp++, 0, 0, &VbarPattern );
			}
			DrawSetLine( dp++, x-10, y-10, x, y, ColorGray,
								OptionFill );
			DrawSetSymbol( dp++, 80, 2, bp->mail.title, AttrDefault, 12 );
			DrawSetSymbol( dp++, 16, 18, bp->mail.name, AttrDefault, 12 );
			DrawSetSymbol( dp++, 148, 18, bp->mail.year, AttrDefault, 12 );
			DrawSetSymbol( dp++, 214, 18, bp->mail.time, AttrDefault, 12 );
			if( bp->mail.fileflag & M_CLIP ){
				DrawSetSymbol( dp++, 280, 18, "Yt", AttrDefault, 12 );
			}
			WindowDraw( wp, dbuf, dp - dbuf );
			WindowRedraw( bp->bwp );
			if( bp->inpwp )	WindowRedraw( bp->inpwp );
		}
		return	TRUE;

	case EventClose:
		WindowClose( wp );
		if( bp->fbuf )	MFREE( bp->fbuf );
		if( bp->lp )	MFREE( bp->lp );
		free( bp );
		return	TRUE;

	case EventMouseSwitch:
		if( bp->inpwp )	return TRUE;

		if( info->LeftON ){
			if( info->x >= HS_WindowGetViewSizeX( wp )-10
				&& info->y >= HS_WindowGetViewSizeY( wp )-10 )
				WindowResizeOperation( wp, info );
			else
				if( ( info->y-= 32 ) >= 0 ){
					WindowSendEvent( bp->bwp, info );
				}else if( info->y < -16 ){
					buttonop( wp, info, bp->send );
				}
			return	TRUE;
		}
		break;

	case EventResize:
		WindowResize( bp->bwp, 0, 32, info->h, info->v - 32 );
		WindowResize( wp, info->x, info->y, info->h, info->v );
		if( bp->inpwp )
			WindowMove( bp->inpwp, 0, HS_WindowGetViewSizeY( bp->bwp )-12 ); 
		WindowRedraw( wp );
		return	TRUE;

	case EventIconify:
		IconEnt( wp, bp->mail.filename, AttrDefault, 12 );
		return	TRUE;

	case EventKey:
		if( bp->inpwp ){
			WindowSendEvent( bp->inpwp, info );
		}else {
			KeyExec( info, bp );
		}
		return  TRUE;
	}
	return	FALSE;
}

void
MV_Open( x, y, h, v, bp )
int	x, y, h, v;
T_BUFP	*bp;
{
	bp->awp= WindowTitleOpen( x, y, h, v, NULL, "mview",
					Icon|Resize|Close|Push, EventExecA );
	bp->bwp= WindowScrollOpen( 0, 32,
					HS_WindowGetViewSizeX(bp->awp),
					HS_WindowGetViewSizeY(bp->awp) - 32,
					bp->awp,
					bp->maxcol* bp->font_x,
					bp->line*bp->font_z,
					DirectionY|DirectionX,
					16, bp->font_z*2, EventExecB );
	bp->inpwp= NULL;
	bp->inputbuf[0]= '\0';
	HS_WindowGetClientPointer(bp->awp)=
	HS_WindowGetClientPointer(bp->bwp)= bp;
	WindowRedraw( bp->awp );
}

