/*
	MicroView.win Copyright 1995 }V
	oga@dgw.yz.yamagata-u.ac.jp
*/

#include	"microview.h"
#include	<mm_alloc.h>
#include	<string.h>


#define		DEFFONT		12
#define		DEFCOL		80
#define		DEFLIN		25
#define		DEFTAB		8

#define		Print(msg)	ConsolePrint(msg)
#define		FOFF		1024

static T_BUFP	BD= {
		0, 0,
		DEFTAB, DEFTAB-1, DEFCOL, 0,
		DEFFONT/2, DEFFONT, DEFFONT,
		AttrDefault, AttrDefault&3,
		0, 0
	};

static int	x= 100,
		y= 0,
		h= -1,
		v= -1;

extern char	nosjis[];

extern unsigned char *	MakeBuf( T_BUFP *bp, int size );
static int	ReadFile(T_BUFP*);

static int
ReadFile(bp)
T_BUFP	*bp;
{
	int	size;
	char	filename[FILNMAX];

	strcpy(filename, bp->cdir);
	strcat(filename, bp->mail.filename);

	size = fsize(filename);
	if (size > 0) {
		struct _stdbuf	string;

		if (!(bp->lp= malloc(size + FOFF))) {
			Print("mview : Can't alloc memory.");
			return	FALSE;
		}

		/* obt@ FILE \̂ɍv */
		string._ptr = string._base = (unsigned char*)bp->lp + FOFF;
		string._cnt = string._bufsiz = size;
		string._flag = _IOWRITE | _IOW | _IOBIN;
		string._file = -1;
		string._nback = 0;

		MakeViewFile(bp->cdir, &(bp->mail), &string, NULL);
		size = string._bufsiz - string._cnt;
		if (!size) {
			free(bp->lp);
			return FALSE;
		}
		realloc(bp->lp, size + FOFF);
		if (!(bp->fbuf = malloc(size * 2))) {
			free(bp->lp);
			Print("mview : Can't alloc memory.");
			return	FALSE;
		}
		size = MakeBuf(bp, size) - bp->fbuf;
		realloc(bp->fbuf, size);
		realloc(bp->lp, sizeof(char*) * bp->line);
		return	size;
	}
	Print("mview : open error");
	return	FALSE;
}


int
BPopen( maildata, dir, send )
MAILDATA	*maildata;
char	*dir;
int	send;
{
	T_BUFP	*bp;

	if (h < 0 || v < 0) {
		h= BD.maxcol*BD.font_x+14;
		v= DEFLIN*BD.font_y;
	}
	if (bp = (void*)malloc(sizeof(T_BUFP))) {
		*bp= BD;
		strcpy(bp->cdir, dir);
		bp->send = send;
		bp->mail = *maildata;
		if (ReadFile(bp)) {
			MV_Open(x, y, h, v, bp);
			return	TRUE;
		}
		free(bp);
	}else
		ConsoleAutoPrint("mview:HEAPs\r\n");
	return	FALSE;
}

void
viewinit( opt )
char	*opt;
{
	extern char	*get_word( char*, char* );
	int	rx, ry;
	char	temp[128], *ptr= opt;

	WindowGetRootScroll( &rx, &ry );

	while( 1 ){
		ptr= get_word( temp, ptr );
		if( !*temp )	break;
		if( *temp == '-' ){
			switch( temp[1] ){
			case 'x':
				x= atoi2( temp+2 )+rx;
				break;
			case 'y':
				y= atoi2( temp+2 )+ry;
				break;
			case 'h':
				h= atoi2( temp+2 );
				break;
			case 'v':
				v= atoi2( temp+2 );
				break;
			case 't':
				BD.tabsize= atoi2(temp+2);
				BD.tabmask= BD.tabsize-1;
				break;
			case 'a':
				BD.attr= atoi2(temp+2);
				BD.backattr= BD.attr & AttrReverse ?
							BD.attr & 3 : 0;
				break;
			case 'c':
				BD.maxcol= atoi2(temp+2);
				break;
			case 'f':
				BD.font_z= BD.font_y= atoi2(temp+2);
				BD.font_x= BD.font_y/2;
				break;
			case 'F':
				BD.font_z= atoi2(temp+2);
				break;
			}
		}
	}
}

